//! #Forez member information
//!
//! @author Pierre Hubert

use serde::Serialize;

use crate::api_data::group_member_api::GroupMemberAPI;
use crate::api_data::user_info::{APIAdvancedInfo, APIUserInfo};
use crate::data::error::Res;
use crate::data::group_member::GroupMember;
use crate::data::user::{User, UserID};

#[derive(Serialize)]
pub struct ForezMemberAPI {
    user: APIAdvancedInfo,
    membership: GroupMemberAPI,
}

impl ForezMemberAPI {
    pub fn new(user: &User, membership: &GroupMember, request_from: UserID) -> Res<Self> {
        Ok(Self {
            user: APIUserInfo::new_advanced_info(&Some(request_from.clone()), user)?,
            membership: GroupMemberAPI::new(membership),
        })
    }
}